import { HTTPMethods } from "fastify";
import { ApiParam, ApiParamType } from "../types/types";
export type ServiceClient = "axios" | "axios-multipart" | "swr" | "socketio" | "window-fetch";
export type ApiDecoratorOptions = {
    httpMethod?: HTTPMethods;
    contentType?: "text/plain" | "text/html" | "text/xml" | "application/json" | "application/octet-stream";
    clients?: ServiceClient[];
    path?: string;
    resourceName?: string;
    guards?: string[];
    description?: string;
};
export declare const registeredApis: {
    modelName: string;
    methodName: string;
    path: string;
    options: ApiDecoratorOptions;
}[];
export type ExtendedApi = {
    modelName: string;
    methodName: string;
    path: string;
    options: ApiDecoratorOptions;
    typeParameters: ApiParamType.TypeParam[];
    parameters: ApiParam[];
    returnType: ApiParamType;
};
export declare function api(options?: ApiDecoratorOptions): (target: Object, propertyKey: string) => void;
//# sourceMappingURL=decorators.d.ts.map