"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.api = exports.registeredApis = void 0;
const inflection_1 = require("inflection");
exports.registeredApis = [];
function api(options = {}) {
    options = Object.assign({ httpMethod: "GET", contentType: "application/json", clients: ["axios"] }, options);
    return function (target, propertyKey) {
        var _a;
        const modelName = target.constructor.name.match(/(.+)Class$/)[1];
        const methodName = propertyKey;
        const defaultPath = `/${(0, inflection_1.camelize)(modelName.replace(/Model$/, ""), true)}/${(0, inflection_1.camelize)(propertyKey, true)}`;
        const api = {
            modelName,
            methodName,
            path: (_a = options.path) !== null && _a !== void 0 ? _a : defaultPath,
            options,
        };
        exports.registeredApis.push(api);
    };
}
exports.api = api;
//# sourceMappingURL=decorators.js.map