/// <reference types="node" />
import { FastifyInstance, FastifyReply, FastifyRequest } from "fastify";
import { IncomingMessage, Server, ServerResponse } from "http";
import { Context } from "./context";
import { Syncer } from "../syncer/syncer";
import { SonamuDBConfig } from "../database/db";
export declare type SonamuConfig = {
    api: {
        dir: string;
    };
    sync: {
        targets: string[];
    };
    route: {
        prefix: string;
    };
};
declare type SonamuFastifyConfig = {
    contextProvider: (defaultContext: Pick<Context, "headers" | "reply">, request: FastifyRequest, reply: FastifyReply) => Context;
};
declare class SonamuClass {
    isInitialized: boolean;
    private _apiRootPath;
    set apiRootPath(apiRootPath: string);
    get apiRootPath(): string;
    get appRootPath(): string;
    private _dbConfig;
    set dbConfig(dbConfig: SonamuDBConfig);
    get dbConfig(): SonamuDBConfig;
    private _syncer;
    set syncer(syncer: Syncer);
    get syncer(): Syncer;
    private _config;
    set config(config: SonamuConfig);
    get config(): SonamuConfig;
    init(): Promise<void>;
    withFastify(server: FastifyInstance<Server, IncomingMessage, ServerResponse>, config: SonamuFastifyConfig): Promise<void>;
    destroy(): Promise<void>;
}
export declare const Sonamu: SonamuClass;
export {};
//# sourceMappingURL=init.d.ts.map