"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* Global Begin */
const chalk_1 = __importDefault(require("chalk"));
console.log(chalk_1.default.bgBlue(`BEGIN ${new Date()}`));
const dotenv_1 = __importDefault(require("dotenv"));
dotenv_1.default.config();
const path_1 = __importDefault(require("path"));
const base_model_1 = require("../database/base-model");
const entity_manager_1 = require("../entity/entity-manager");
const migrator_1 = require("../entity/migrator");
const fixture_manager_1 = require("../testing/fixture-manager");
const tsicli_1 = require("tsicli");
const child_process_1 = require("child_process");
const fs_1 = require("fs");
const api_1 = require("../api");
const knex_1 = __importDefault(require("knex"));
const inflection_1 = require("inflection");
const prettier_1 = __importDefault(require("prettier"));
const smd_manager_1 = require("../smd/smd-manager");
const process_1 = __importDefault(require("process"));
let migrator;
function bootstrap() {
    return __awaiter(this, void 0, void 0, function* () {
        yield api_1.Sonamu.init();
        yield (0, tsicli_1.tsicli)(process_1.default.argv, {
            types: {
                "#entityId": {
                    type: "autocomplete",
                    name: "#entityId",
                    message: "Please input #entityId",
                    choices: entity_manager_1.EntityManager.getAllParentIds().map((entityId) => ({
                        title: entityId,
                        value: entityId,
                    })),
                },
                "#recordIds": "number[]",
                "#name": "string",
            },
            args: [
                ["fixture", "init"],
                ["fixture", "import", "#entityId", "#recordIds"],
                ["fixture", "sync"],
                ["migrate", "run"],
                ["migrate", "check"],
                ["migrate", "rollback"],
                ["migrate", "reset"],
                ["migrate", "clear"],
                ["stub", "practice", "#name"],
                ["stub", "entity", "#name"],
                ["scaffold", "model", "#entityId"],
                ["scaffold", "model_test", "#entityId"],
                ["scaffold", "view_list", "#entityId"],
                ["scaffold", "view_form", "#entityId"],
                ["ui"],
                ["smd_migration"],
            ],
            runners: {
                migrate_run,
                migrate_check,
                migrate_rollback,
                migrate_clear,
                migrate_reset,
                fixture_init,
                fixture_import,
                fixture_sync,
                stub_practice,
                stub_entity,
                scaffold_model,
                scaffold_model_test,
                ui,
                // scaffold_view_list,
                // scaffold_view_form,
                smd_migration,
            },
        });
    });
}
bootstrap().finally(() => __awaiter(void 0, void 0, void 0, function* () {
    if (migrator) {
        yield migrator.destroy();
    }
    yield fixture_manager_1.FixtureManager.destory();
    yield base_model_1.BaseModel.destroy();
    /* Global End */
    console.log(chalk_1.default.bgBlue(`END ${new Date()}\n`));
}));
function setupMigrator() {
    return __awaiter(this, void 0, void 0, function* () {
        // migrator
        migrator = new migrator_1.Migrator({
            mode: "dev",
        });
    });
}
function setupFixtureManager() {
    return __awaiter(this, void 0, void 0, function* () {
        fixture_manager_1.FixtureManager.init();
    });
}
function migrate_run() {
    return __awaiter(this, void 0, void 0, function* () {
        yield setupMigrator();
        yield migrator.cleanUpDist();
        yield migrator.run();
    });
}
function migrate_check() {
    return __awaiter(this, void 0, void 0, function* () {
        yield setupMigrator();
        yield migrator.cleanUpDist();
        yield migrator.check();
    });
}
function migrate_rollback() {
    return __awaiter(this, void 0, void 0, function* () {
        yield setupMigrator();
        yield migrator.rollback();
    });
}
function migrate_clear() {
    return __awaiter(this, void 0, void 0, function* () {
        yield setupMigrator();
        yield migrator.clearPendingList();
    });
}
function migrate_reset() {
    return __awaiter(this, void 0, void 0, function* () {
        yield setupMigrator();
        yield migrator.resetAll();
    });
}
function fixture_init() {
    var _a, e_1, _b, _c;
    var _d;
    return __awaiter(this, void 0, void 0, function* () {
        const srcConfig = api_1.Sonamu.dbConfig.development_master;
        const targets = [
            {
                label: "(REMOTE) Fixture DB",
                config: api_1.Sonamu.dbConfig.fixture_remote,
            },
            {
                label: "(LOCAL) Fixture DB",
                config: api_1.Sonamu.dbConfig.fixture_local,
                toSkip: (() => {
                    const remoteConn = api_1.Sonamu.dbConfig.fixture_remote
                        .connection;
                    const localConn = api_1.Sonamu.dbConfig.fixture_local
                        .connection;
                    return (remoteConn.host === localConn.host &&
                        remoteConn.database === localConn.database);
                })(),
            },
            {
                label: "(LOCAL) Testing DB",
                config: api_1.Sonamu.dbConfig.test,
            },
        ];
        // 1. 기준DB 스키마를 덤프
        console.log("DUMP...");
        const dumpFilename = `/tmp/sonamu-fixture-init-${Date.now()}.sql`;
        const srcConn = srcConfig.connection;
        (0, child_process_1.execSync)(`mysqldump -h${srcConn.host} -u${srcConn.user} -p${srcConn.password} --single-transaction -d --no-create-db --triggers ${srcConn.database} > ${dumpFilename}`);
        try {
            // 2. 대상DB 각각에 대하여 존재여부 확인 후 붓기
            for (var _e = true, targets_1 = __asyncValues(targets), targets_1_1; targets_1_1 = yield targets_1.next(), _a = targets_1_1.done, !_a; _e = true) {
                _c = targets_1_1.value;
                _e = false;
                const { label, config, toSkip } = _c;
                const conn = config.connection;
                if (toSkip === true) {
                    console.log(chalk_1.default.red(`${label}: Skipped!`));
                    continue;
                }
                const db = (0, knex_1.default)(Object.assign(Object.assign({}, config), { connection: Object.assign(Object.assign({}, ((_d = config.connection) !== null && _d !== void 0 ? _d : {})), { database: undefined }) }));
                const [[row]] = yield db.raw(`SHOW DATABASES LIKE "${conn.database}"`);
                if (row) {
                    console.log(chalk_1.default.yellow(`${label}: Database "${conn.database} Already exists`));
                    yield db.destroy();
                    continue;
                }
                console.log(`SYNC to ${label}...`);
                const mysqlCmd = `mysql -h${conn.host} -u${conn.user} -p${conn.password}`;
                (0, child_process_1.execSync)(`${mysqlCmd} -e 'DROP DATABASE IF EXISTS ${conn.database}'`);
                (0, child_process_1.execSync)(`${mysqlCmd} -e 'CREATE DATABASE ${conn.database}'`);
                (0, child_process_1.execSync)(`${mysqlCmd} ${conn.database} < ${dumpFilename}`);
                yield db.destroy();
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (!_e && !_a && (_b = targets_1.return)) yield _b.call(targets_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
}
function fixture_import(entityId, recordIds) {
    return __awaiter(this, void 0, void 0, function* () {
        yield setupFixtureManager();
        yield fixture_manager_1.FixtureManager.importFixture(entityId, recordIds);
        yield fixture_manager_1.FixtureManager.sync();
    });
}
function fixture_sync() {
    return __awaiter(this, void 0, void 0, function* () {
        yield setupFixtureManager();
        yield fixture_manager_1.FixtureManager.sync();
    });
}
function stub_practice(name) {
    return __awaiter(this, void 0, void 0, function* () {
        const practiceDir = path_1.default.join(api_1.Sonamu.apiRootPath, "src", "practices");
        const fileNames = (0, fs_1.readdirSync)(practiceDir);
        const maxSeqNo = (() => {
            if ((0, fs_1.existsSync)(practiceDir) === false) {
                (0, fs_1.mkdirSync)(practiceDir, { recursive: true });
            }
            const filteredSeqs = fileNames
                .filter((fileName) => fileName.startsWith("p") && fileName.endsWith(".ts"))
                .map((fileName) => {
                var _a;
                const [, seqNo] = (_a = fileName.match(/^p([0-9]+)\-/)) !== null && _a !== void 0 ? _a : ["0", "0"];
                return parseInt(seqNo);
            })
                .sort((a, b) => b - a);
            if (filteredSeqs.length > 0) {
                return filteredSeqs[0];
            }
            return 0;
        })();
        const currentSeqNo = maxSeqNo + 1;
        const fileName = `p${currentSeqNo}-${name}.ts`;
        const dstPath = path_1.default.join(practiceDir, fileName);
        const code = [
            `import { BaseModel } from "sonamu";`,
            "",
            `console.clear();`,
            `console.log("${fileName}");`,
            "",
            `async function bootstrap() {`,
            ` // TODO`,
            `}`,
            `bootstrap().finally(async () => {`,
            `await BaseModel.destroy();`,
            `});`,
        ].join("\n");
        (0, fs_1.writeFileSync)(dstPath, code);
        (0, child_process_1.execSync)(`code ${dstPath}`);
        const runCode = `yarn node -r source-map-support/register dist/practices/${fileName.replace(".ts", ".js")}`;
        console.log(`${chalk_1.default.blue(runCode)} copied to clipboard.`);
        (0, child_process_1.execSync)(`echo "${runCode}" | pbcopy`);
    });
}
function stub_entity(entityId) {
    return __awaiter(this, void 0, void 0, function* () {
        yield api_1.Sonamu.syncer.createEntity(entityId);
    });
}
function scaffold_model(entityId) {
    return __awaiter(this, void 0, void 0, function* () {
        yield api_1.Sonamu.syncer.generateTemplate("model", {
            entityId,
        });
    });
}
function scaffold_model_test(entityId) {
    return __awaiter(this, void 0, void 0, function* () {
        yield api_1.Sonamu.syncer.generateTemplate("model_test", {
            entityId,
        });
    });
}
function ui() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const sonamuUI = yield Promise.resolve(`${"@sonamu-kit/ui"}`).then(s => __importStar(require(s)));
            sonamuUI.startServers(api_1.Sonamu.appRootPath);
        }
        catch (e) {
            if (e instanceof Error && e.message.includes("isn't declared")) {
                console.log(`You need to install ${chalk_1.default.blue(`@sonamu-kit/ui`)} first.`);
                return;
            }
            throw e;
        }
    });
}
function smd_migration() {
    var _a, e_2, _b, _c, _d, e_3, _e, _f;
    var _g;
    return __awaiter(this, void 0, void 0, function* () {
        yield smd_manager_1.SMDManager.autoload();
        const smdIds = smd_manager_1.SMDManager.getAllIds();
        function enumLabelsToEntityEnums(entityId, enumLabels) {
            return Object.fromEntries(Object.entries(enumLabels).map(([enumLabelName, enumLabel]) => {
                const enumName = entityId + (0, inflection_1.camelize)(enumLabelName.toLowerCase(), false);
                return [
                    enumName,
                    Object.fromEntries(Object.entries(enumLabel).map(([name, { ko }]) => [name, ko])),
                ];
            }));
        }
        try {
            for (var _h = true, smdIds_1 = __asyncValues(smdIds), smdIds_1_1; smdIds_1_1 = yield smdIds_1.next(), _a = smdIds_1_1.done, !_a; _h = true) {
                _c = smdIds_1_1.value;
                _h = false;
                const smdId = _c;
                const smd = smd_manager_1.SMDManager.get(smdId);
                const entityJson = Object.assign(Object.assign({ id: smd.id }, (smd.parentId ? { parentId: smd.parentId } : {})), { title: smd.title, props: smd.props, indexes: smd.indexes, subsets: smd.subsets, enums: enumLabelsToEntityEnums(smd.id, smd.enumLabels) });
                const parentNames = smd_manager_1.SMDManager.getNamesFromId((_g = smd.parentId) !== null && _g !== void 0 ? _g : smd.id);
                const names = smd_manager_1.SMDManager.getNamesFromId(smd.id);
                const dstPath = path_1.default.join(api_1.Sonamu.apiRootPath, "src", "application", parentNames.fs, `${names.fs}.entity.json`);
                const formatted = prettier_1.default.format(JSON.stringify(entityJson), {
                    parser: "json",
                });
                (0, fs_1.writeFileSync)(dstPath, formatted);
                console.log(chalk_1.default.blue(`CREATED: ${dstPath}`));
                // smd.ts, enums.ts, genereated.ts 삭제 (트랜스파일 된 js파일도 삭제)
                const srcSmdPath = path_1.default.join(api_1.Sonamu.apiRootPath, "src", "application", parentNames.fs, `${names.fs}.smd.ts`);
                const dstSmdPath = srcSmdPath
                    .replace("/src/", "/dist/")
                    .replace(/\.ts$/, ".js");
                const srcEnumsPath = path_1.default.join(api_1.Sonamu.apiRootPath, "src", "application", parentNames.fs, `${names.fs}.enums.ts`);
                const dstEnumsPath = srcEnumsPath
                    .replace("/src/", "/dist/")
                    .replace(/\.ts$/, ".js");
                const srcGeneratedPath = path_1.default.join(api_1.Sonamu.apiRootPath, "src", "application", parentNames.fs, `${names.fs}.generated.ts`);
                const dstGeneratedPath = srcGeneratedPath
                    .replace("/src/", "/dist/")
                    .replace(/\.ts$/, ".js");
                [
                    srcSmdPath,
                    dstSmdPath,
                    srcEnumsPath,
                    dstEnumsPath,
                    ...api_1.Sonamu.config.sync.targets.map((target) => srcEnumsPath
                        .replace(api_1.Sonamu.apiRootPath, path_1.default.join(api_1.Sonamu.appRootPath, target))
                        .replace("/src/application/", "/src/services/")),
                    srcGeneratedPath,
                    dstGeneratedPath,
                ].map((p) => {
                    if ((0, fs_1.existsSync)(p) === false) {
                        console.log(chalk_1.default.yellow(`NOT FOUND: ${p}`));
                        return;
                    }
                    (0, fs_1.unlinkSync)(p);
                    console.log(chalk_1.default.red(`DELETED: ${p}`));
                });
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (!_h && !_a && (_b = smdIds_1.return)) yield _b.call(smdIds_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        // Entity로 reload
        console.log("Entity로 다시 로드합니다.");
        entity_manager_1.EntityManager.isAutoloaded = false;
        yield entity_manager_1.EntityManager.autoload();
        // Entity를 통해 generated.ts 재생성
        const entityIds = entity_manager_1.EntityManager.getAllParentIds();
        try {
            for (var _j = true, entityIds_1 = __asyncValues(entityIds), entityIds_1_1; entityIds_1_1 = yield entityIds_1.next(), _d = entityIds_1_1.done, !_d; _j = true) {
                _f = entityIds_1_1.value;
                _j = false;
                const entityId = _f;
                yield api_1.Sonamu.syncer.generateTemplate("generated", { entityId });
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (!_j && !_d && (_e = entityIds_1.return)) yield _e.call(entityIds_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
    });
}
//# sourceMappingURL=cli.js.map