import { Knex } from "knex";
import { DBPreset } from "./db";
import { SubsetQuery } from "../types/types";
import { BaseListParams } from "../utils/model";
import { UpsertBuilder } from "./upsert-builder";
export declare class BaseModelClass {
    modelName: string;
    getDB(which: DBPreset): Knex;
    destroy(): Promise<void>;
    myNow(timestamp?: number): string;
    getInsertedIds(wdb: Knex, rows: any[], tableName: string, unqKeyFields: string[], chunkSize?: number): Promise<number[]>;
    useLoaders(db: Knex, rows: any[], loaders: SubsetQuery["loaders"]): Promise<any[]>;
    hydrate<T>(rows: T[]): T[];
    runSubsetQuery<T extends BaseListParams, U extends string>({ params, baseTable, subset, subsetQuery, build, debug, db: _db, }: {
        subset: U;
        params: T;
        subsetQuery: SubsetQuery;
        build: (buildParams: {
            qb: Knex.QueryBuilder;
            db: Knex;
            select: (string | Knex.Raw)[];
            joins: SubsetQuery["joins"];
            virtual: string[];
        }) => Knex.QueryBuilder;
        baseTable?: string;
        debug?: boolean | "list" | "count";
        db?: Knex;
    }): Promise<{
        rows: any[];
        total?: number | undefined;
        subsetQuery: SubsetQuery;
        qb: Knex.QueryBuilder;
    }>;
    getJoinClause(db: Knex<any, unknown>, join: SubsetQuery["joins"][number]): Knex.Raw<any>;
    getUpsertBuilder(): UpsertBuilder;
}
export declare const BaseModel: BaseModelClass;
//# sourceMappingURL=base-model.d.ts.map