"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DB = void 0;
const knex_1 = __importDefault(require("knex"));
const path_1 = __importDefault(require("path"));
const api_1 = require("../api");
const so_exceptions_1 = require("../exceptions/so-exceptions");
class DBClass {
    readKnexfile() {
        return __awaiter(this, void 0, void 0, function* () {
            const dbConfigPath = path_1.default.join(api_1.Sonamu.apiRootPath, "/dist/configs/db");
            try {
                const knexfileModule = yield Promise.resolve(`${dbConfigPath}`).then(s => __importStar(require(s)));
                return knexfileModule.default;
            }
            catch (_a) { }
            throw new so_exceptions_1.ServiceUnavailableException(`DB설정 파일을 찾을 수 없습니다. ${dbConfigPath}`);
        });
    }
    getDB(which) {
        var _a, _b, _c;
        const dbConfig = api_1.Sonamu.dbConfig;
        const instanceName = which === "w" ? "wdb" : "rdb";
        if (!this[instanceName]) {
            let config;
            switch ((_a = process.env.NODE_ENV) !== null && _a !== void 0 ? _a : "development") {
                case "development":
                case "staging":
                    config =
                        which === "w"
                            ? dbConfig["development_master"]
                            : (_b = dbConfig["development_slave"]) !== null && _b !== void 0 ? _b : dbConfig["development_master"];
                    break;
                case "production":
                    config =
                        which === "w"
                            ? dbConfig["production_master"]
                            : (_c = dbConfig["production_slave"]) !== null && _c !== void 0 ? _c : dbConfig["production_master"];
                    break;
                case "test":
                    config = dbConfig["test"];
                    break;
                default:
                    throw new Error(`현재 ENV ${process.env.NODE_ENV}에는 설정 가능한 DB설정이 없습니다.`);
            }
            this[instanceName] = (0, knex_1.default)(config);
        }
        return this[instanceName];
    }
    destroy() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.wdb !== undefined) {
                yield this.wdb.destroy();
                this.wdb = undefined;
            }
            if (this.rdb !== undefined) {
                yield this.rdb.destroy();
                this.rdb = undefined;
            }
        });
    }
}
exports.DB = new DBClass();
//# sourceMappingURL=db.js.map