import { Knex } from "knex";
type TableData = {
    references: Set<string>;
    rows: any[];
    uniqueColumns: string[];
    uniquesMap: Map<string, string>;
};
export type UBRef = {
    uuid: string;
    of: string;
    use?: string;
};
export declare function isRefField(field: any): field is UBRef;
export declare class UpsertBuilder {
    tables: Map<string, TableData>;
    constructor();
    getTable(tableName: string): TableData;
    hasTable(tableName: string): boolean;
    register<T extends string>(tableName: string, row: {
        [key in T]?: UBRef | string | number | boolean | bigint | null | object | unknown;
    }): UBRef;
    upsert(wdb: Knex, tableName: string): Promise<number[]>;
    insertOnly(wdb: Knex, tableName: string): Promise<number[]>;
    upsertOrInsert(wdb: Knex, tableName: string, mode: "upsert" | "insert"): Promise<number[]>;
    updateBatch(wdb: Knex, tableName: string, options?: {
        chunkSize?: number;
        where?: string;
    }): Promise<void>;
}
export {};
//# sourceMappingURL=upsert-builder.d.ts.map