import { BelongsToOneRelationProp, BigIntegerProp, BooleanProp, DateProp, DateTimeProp, DecimalProp, DistributiveOmit, DoubleProp, EnumProp, FloatProp, HasManyRelationProp, IntegerProp, JsonProp, ManyToManyRelationProp, OneToOneRelationProp, EntityIndex, StringProp, TextProp, TimeProp, TimestampProp, UuidProp, VirtualProp } from "../types/types";
export declare const p: {
    integer: typeof integer;
    bigInteger: typeof bigInteger;
    text: typeof text;
    string: typeof string;
    float: typeof float;
    double: typeof double;
    decimal: typeof decimal;
    boolean: typeof boolean;
    date: typeof date;
    dateTime: typeof dateTime;
    time: typeof time;
    timestamp: typeof timestamp;
    json: typeof json;
    uuid: typeof uuid;
    enums: typeof enums;
    virtual: typeof virtual;
    relationOneToOne: typeof relationOneToOne;
    relationBelongsToOne: typeof relationBelongsToOne;
    relationHasMany: typeof relationHasMany;
    relationManyToMany: typeof relationManyToMany;
};
declare function integer(name: string, option?: Omit<IntegerProp, "name" | "type">): IntegerProp;
declare function bigInteger(name: string, option?: Omit<BigIntegerProp, "name" | "type">): BigIntegerProp;
declare function text(name: string, option: Omit<TextProp, "name" | "type">): TextProp;
declare function string(name: string, option: Omit<StringProp, "name" | "type">): StringProp;
declare function float(name: string, option?: Omit<FloatProp, "name" | "type">): FloatProp;
declare function double(name: string, option?: Omit<DoubleProp, "name" | "type">): DoubleProp;
declare function decimal(name: string, option?: Omit<DecimalProp, "name" | "type">): DecimalProp;
declare function boolean(name: string, option?: Omit<BooleanProp, "name" | "type">): BooleanProp;
declare function date(name: string, option?: Omit<DateProp, "name" | "type"> & {
    now?: true;
}): DateProp;
declare function dateTime(name: string, option?: Omit<DateTimeProp, "name" | "type"> & {
    now?: true;
}): DateTimeProp;
declare function time(name: string, option?: Omit<TimeProp, "name" | "type"> & {
    now?: true;
}): TimeProp;
declare function timestamp(name: string, option?: Omit<TimestampProp, "name" | "type"> & {
    now?: true;
}): TimestampProp;
declare function json(name: string, option: Omit<JsonProp, "name" | "type">): JsonProp;
declare function uuid(name: string, option: Omit<UuidProp, "name" | "type">): UuidProp;
declare function enums(name: string, option: Omit<EnumProp, "name" | "type" | "id"> & {
    id?: string;
}): EnumProp;
declare function virtual(name: string, option: Omit<VirtualProp, "name" | "type" | "dbDefault" | "toFilter">): VirtualProp;
declare function relationOneToOne(name: string, option: DistributiveOmit<OneToOneRelationProp, "name" | "type" | "relationType">): OneToOneRelationProp;
declare function relationBelongsToOne(name: string, option: Omit<BelongsToOneRelationProp, "name" | "type" | "relationType">): BelongsToOneRelationProp;
declare function relationHasMany(name: string, option: Omit<HasManyRelationProp, "name" | "type" | "relationType">): HasManyRelationProp;
declare function relationManyToMany(name: string, option: Omit<ManyToManyRelationProp, "name" | "type" | "relationType">): ManyToManyRelationProp;
export declare const i: {
    index: typeof index;
    unique: typeof unique;
};
declare function index(columns: string | string[]): EntityIndex;
declare function unique(columns: string | string[]): EntityIndex;
export {};
//# sourceMappingURL=smd-utils.d.ts.map