export declare abstract class SoException extends Error {
    readonly statusCode: number;
    message: string;
    payload?: unknown;
    constructor(statusCode: number, message: string, payload?: unknown);
}
export declare function isSoException(err: any): err is SoException;
export declare class BadRequestException extends SoException {
    message: string;
    payload?: unknown;
    constructor(message?: string, payload?: unknown);
}
export declare class UnauthorizedException extends SoException {
    message: string;
    payload?: unknown;
    constructor(message?: string, payload?: unknown);
}
export declare class NotFoundException extends SoException {
    message: string;
    payload?: unknown;
    constructor(message?: string, payload?: unknown);
}
export declare class ServiceUnavailableException extends SoException {
    message: string;
    payload?: unknown;
    constructor(message?: string, payload?: unknown);
}
export declare class InternalServerErrorException extends SoException {
    message: string;
    payload?: unknown;
    constructor(message?: string, payload?: unknown);
}
export declare class AlreadyProcessedException extends SoException {
    message: string;
    payload?: unknown;
    constructor(message?: string, payload?: unknown);
}
export declare class DuplicateRowException extends SoException {
    message: string;
    payload?: unknown;
    constructor(message?: string, payload?: unknown);
}
export declare class TargetNotFoundException extends SoException {
    message: string;
    payload?: unknown;
    constructor(message?: string, payload?: unknown);
}
//# sourceMappingURL=so-exceptions.d.ts.map