import { Entity } from "./entity";
import { SMDInput } from "../types/types";
export declare type EntityNamesRecord = Record<"fs" | "fsPlural" | "camel" | "camelPlural" | "capital" | "capitalPlural" | "upper" | "constant", string>;
declare type TableSpec = {
    name: string;
    uniqueColumns: string[];
};
declare class EntityManagerClass {
    private entities;
    modulePaths: Map<string, string>;
    private tableSpecs;
    isAutoloaded: boolean;
    autoload(doSilent?: boolean): Promise<unknown>;
    register(smdInput: SMDInput<string>): void;
    get(entityId: string): Entity;
    exists(entityId: string): boolean;
    getAllIds(): string[];
    getAllParentIds(): string[];
    getChildrenIds(parentId: string): string[];
    setModulePath(key: string, modulePath: string): void;
    getModulePath(key: string): string;
    setTableSpec(tableSpec: TableSpec): void;
    getTableSpec(key: string): TableSpec;
    getNamesFromId(entityId: string): EntityNamesRecord;
}
export declare const EntityManager: EntityManagerClass;
export {};
//# sourceMappingURL=entity-manager.d.ts.map