import { EntityProp, RelationProp, SMDInput, SubsetQuery, EntityPropNode, EntityIndex } from "../types/types";
import { z } from "zod";
export declare class Entity {
    id: string;
    parentId?: string;
    table: string;
    title: string;
    names: {
        fs: string;
        module: string;
    };
    props: EntityProp[];
    propsDict: {
        [key: string]: EntityProp;
    };
    relations: {
        [key: string]: RelationProp;
    };
    indexes: EntityIndex[];
    subsets: {
        [key: string]: string[];
    };
    types: {
        [name: string]: z.ZodTypeAny;
    };
    enums: {
        [name: string]: z.ZodEnum<any>;
    };
    enumLabels: {
        [name: string]: string;
    };
    constructor({ id, parentId, table, title, props, indexes, subsets, }: SMDInput<any>);
    getSubsetQuery(subsetKey: string): SubsetQuery;
    resolveSubsetQuery(prefix: string, fields: string[], isAlreadyOuterJoined?: boolean): SubsetQuery;
    fieldExprsToPropNodes(fieldExprs: string[], smd?: Entity): EntityPropNode[];
    getFieldExprs(prefix?: string, maxDepth?: number, froms?: string[]): string[];
    registerModulePaths(): void;
    registerTableSpecs(): void;
}
//# sourceMappingURL=entity.d.ts.map