import { SMD } from "./smd";
import { SMDInput } from "../types/types";
import { EntityNamesRecord } from "../entity/entity-manager";
type TableSpec = {
    name: string;
    uniqueColumns: string[];
};
declare class SMDManagerClass {
    private SMDs;
    modulePaths: Map<string, string>;
    private tableSpecs;
    isAutoloaded: boolean;
    autoload(doSilent?: boolean): Promise<unknown>;
    register(smdInput: SMDInput<string>): void;
    get(smdId: string): SMD;
    exists(smdId: string): boolean;
    getAllIds(): string[];
    getAllParentIds(): string[];
    getChildrenIds(parentId: string): string[];
    setModulePath(key: string, modulePath: string): void;
    getModulePath(key: string): string;
    setTableSpec(tableSpec: TableSpec): void;
    getTableSpec(key: string): TableSpec;
    getNamesFromId(smdId: string): EntityNamesRecord;
}
export declare const SMDManager: SMDManagerClass;
export {};
//# sourceMappingURL=smd-manager.d.ts.map