"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Template__entity = void 0;
const entity_manager_1 = require("../entity/entity-manager");
const base_template_1 = require("./base-template");
class Template__entity extends base_template_1.Template {
    constructor() {
        super("entity");
    }
    getTargetAndPath(names, parentNames) {
        return {
            target: "api/src/application",
            path: `${(parentNames !== null && parentNames !== void 0 ? parentNames : names).fs}/${names.fs}.entity.json`,
        };
    }
    render(options) {
        var _a;
        const { entityId, title, parentId, table } = options;
        const names = entity_manager_1.EntityManager.getNamesFromId(entityId);
        const parent = (() => {
            if (parentId) {
                return {
                    names: entity_manager_1.EntityManager.getNamesFromId(parentId),
                    entity: entity_manager_1.EntityManager.get(parentId),
                };
            }
            else {
                return null;
            }
        })();
        return Object.assign(Object.assign({}, this.getTargetAndPath(names, (_a = parent === null || parent === void 0 ? void 0 : parent.names) !== null && _a !== void 0 ? _a : names)), { body: JSON.stringify({
                id: entityId,
                title: title !== null && title !== void 0 ? title : entityId,
                parentId,
                table: table !== null && table !== void 0 ? table : names.fsPlural.replace(/\-/g, "_"),
                props: [
                    { name: "id", type: "integer", unsigned: true, desc: "ID" },
                    ...(parent
                        ? [
                            {
                                type: "relation",
                                name: parent.names.camel,
                                relationType: "BelongsToOne",
                                with: parentId,
                                onUpdate: "CASCADE",
                                onDelete: "CASCADE",
                                desc: parent.entity.title,
                            },
                        ]
                        : []),
                    {
                        name: "created_at",
                        type: "timestamp",
                        desc: "등록일시",
                        dbDefault: "CURRENT_TIMESTAMP",
                    },
                ],
                indexes: [],
                subsets: Object.assign({}, (parentId
                    ? {}
                    : {
                        A: ["id", "created_at"],
                    })),
                enums: Object.assign({}, (parentId
                    ? {}
                    : {
                        [`${names.capital}OrderBy`]: {
                            "id-desc": "ID최신순",
                        },
                        [`${names.capital}SearchField`]: { id: "ID" },
                    })),
            }).trim(), importKeys: [] });
    }
}
exports.Template__entity = Template__entity;
//# sourceMappingURL=entity.template.js.map