"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Template__generated_http = void 0;
const qs_1 = __importDefault(require("qs"));
const zod_1 = require("zod");
const code_converters_1 = require("../api/code-converters");
const base_template_1 = require("./base-template");
const prettier_1 = __importDefault(require("prettier"));
const sonamu_1 = require("../api/sonamu");
class Template__generated_http extends base_template_1.Template {
    constructor() {
        super("generated_http");
    }
    getTargetAndPath() {
        return {
            target: "api/src/application",
            path: `sonamu.generated.http`,
        };
    }
    render({}) {
        const { syncer: { types, apis }, config: { route: { prefix }, }, } = sonamu_1.Sonamu;
        const lines = apis.map((api) => {
            var _a, _b;
            const reqObject = this.resolveApiParams(api, types);
            const dataLines = (() => {
                var _a;
                if (((_a = api.options.httpMethod) !== null && _a !== void 0 ? _a : "GET") === "GET") {
                    return {
                        querystring: [
                            qs_1.default
                                .stringify(reqObject, { encode: false })
                                .split("&")
                                .join("\n\t&"),
                        ],
                        body: [],
                    };
                }
                else {
                    return {
                        querystring: [],
                        body: [
                            "",
                            prettier_1.default.format(JSON.stringify(reqObject), {
                                parser: "json",
                            }),
                        ],
                    };
                }
            })();
            return [
                [
                    `${(_a = api.options.httpMethod) !== null && _a !== void 0 ? _a : "GET"} {{baseUrl}}${prefix}${api.path}`,
                    ...dataLines.querystring,
                ].join("\n\t?"),
                `Content-Type: ${(_b = api.options.contentType) !== null && _b !== void 0 ? _b : "application/json"}`,
                ...dataLines.body,
            ].join("\n");
        });
        return Object.assign(Object.assign({}, this.getTargetAndPath()), { body: lines.join("\n\n###\n\n"), importKeys: [] });
    }
    zodTypeToReqDefault(zodType, name) {
        var _a;
        if (zodType instanceof zod_1.z.ZodObject) {
            return Object.fromEntries(Object.keys(zodType.shape).map((key) => [
                key,
                this.zodTypeToReqDefault(zodType.shape[key], key),
            ]));
        }
        else if (zodType instanceof zod_1.z.ZodArray) {
            return [this.zodTypeToReqDefault(zodType.element, name)];
        }
        else if (zodType instanceof zod_1.z.ZodString) {
            if (name.endsWith("_at") || name.endsWith("_date") || name === "range") {
                return "2000-01-01";
            }
            else {
                return name.toUpperCase();
            }
        }
        else if (zodType instanceof zod_1.z.ZodNumber) {
            if (name === "num") {
                return 24;
            }
            return (_a = zodType.minValue) !== null && _a !== void 0 ? _a : 0;
        }
        else if (zodType instanceof zod_1.z.ZodBoolean) {
            return false;
        }
        else if (zodType instanceof zod_1.z.ZodEnum) {
            return zodType.options[0];
        }
        else if (zodType instanceof zod_1.z.ZodOptional) {
            return this.zodTypeToReqDefault(zodType._def.innerType, name);
        }
        else if (zodType instanceof zod_1.z.ZodNullable) {
            return null;
        }
        else if (zodType instanceof zod_1.z.ZodUnion) {
            return this.zodTypeToReqDefault(zodType._def.options[0], name);
        }
        else if (zodType instanceof zod_1.z.ZodUnknown) {
            return "unknown";
        }
        else if (zodType instanceof zod_1.z.ZodTuple) {
            return zodType._def.items.map((item) => this.zodTypeToReqDefault(item, name));
        }
        else {
            // console.log(zodType);
            return `unknown-${zodType._type}`;
        }
    }
    resolveApiParams(api, references) {
        const reqType = (0, code_converters_1.getZodObjectFromApi)(api, references);
        return this.zodTypeToReqDefault(reqType, "unknownName");
    }
}
exports.Template__generated_http = Template__generated_http;
//# sourceMappingURL=generated_http.template.js.map