"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Template__generated_sso = void 0;
const entity_manager_1 = require("../entity/entity-manager");
const base_template_1 = require("./base-template");
const inflection_1 = require("inflection");
const lodash_1 = require("lodash");
const utils_1 = require("../utils/utils");
class Template__generated_sso extends base_template_1.Template {
    constructor() {
        super("generated_sso");
    }
    getTargetAndPath() {
        return {
            target: "api/src/application",
            path: `sonamu.generated.sso.ts`,
        };
    }
    render({}) {
        const entityIds = entity_manager_1.EntityManager.getAllIds();
        const entities = entityIds.map((id) => entity_manager_1.EntityManager.get(id));
        const sourceCodes = entities
            .map((entity) => {
            if (entity.parentId !== undefined ||
                Object.keys(entity.subsets).length === 0) {
                return null;
            }
            const subsetKeys = Object.keys(entity.subsets);
            const subsetQueryObject = subsetKeys.reduce((r, subsetKey) => {
                const subsetQuery = entity.getSubsetQuery(subsetKey);
                r[subsetKey] = subsetQuery;
                return r;
            }, {});
            const subsetKeyTypeName = `${entity.names.module}SubsetKey`;
            return {
                label: `SubsetQuery: ${entity.id}`,
                lines: [
                    `export const ${(0, inflection_1.camelize)(entity.id, true)}SubsetQueries:{ [key in ${subsetKeyTypeName}]: SubsetQuery} = ${JSON.stringify(subsetQueryObject)};`,
                    "",
                ],
                importKeys: [subsetKeyTypeName],
            };
        })
            .filter(utils_1.nonNullable);
        const sourceCode = sourceCodes.reduce((result, ts) => {
            if (ts === null) {
                return result;
            }
            return {
                lines: [...result.lines, `// ${ts.label}`, ...ts.lines, ""],
                importKeys: (0, lodash_1.uniq)([...result.importKeys, ...ts.importKeys]),
            };
        }, {
            lines: [],
            importKeys: [],
        });
        return Object.assign(Object.assign({}, this.getTargetAndPath()), { body: sourceCode.lines.join("\n"), importKeys: sourceCode.importKeys, customHeaders: [`import { SubsetQuery } from "sonamu";`] });
    }
}
exports.Template__generated_sso = Template__generated_sso;
//# sourceMappingURL=generated_sso.template.js.map