"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Template__init_enums = void 0;
const inflection_1 = require("inflection");
const entity_manager_1 = require("../entity/entity-manager");
const base_template_1 = require("./base-template");
class Template__init_enums extends base_template_1.Template {
    constructor() {
        super("init_enums");
    }
    getTargetAndPath(names) {
        return {
            target: "api/src/application",
            path: `${names.fs}/${names.fs}.enums.ts`,
        };
    }
    render(options) {
        var _a, _b;
        const { smdId, def } = options;
        const names = entity_manager_1.EntityManager.getNamesFromId(smdId);
        const record = def !== null && def !== void 0 ? def : {};
        (_a = record.ORDER_BY) !== null && _a !== void 0 ? _a : (record.ORDER_BY = {
            "id-desc": "최신순",
        });
        (_b = record.SEARCH_FIELD) !== null && _b !== void 0 ? _b : (record.SEARCH_FIELD = {
            id: "ID",
        });
        return Object.assign(Object.assign({}, this.getTargetAndPath(names)), { body: `
import { z } from "zod";
import { EnumsLabelKo } from "sonamu";

${Object.entries(record)
                .map(([key, value]) => `export const ${smdId}${(0, inflection_1.camelize)(key.toLowerCase(), false)} = z.enum([${Object.keys(value)
                .map((v) => `"${v}"`)
                .join(",")}]);
export type ${smdId}${(0, inflection_1.camelize)(key.toLowerCase(), false)} = z.infer<typeof ${smdId}${(0, inflection_1.camelize)(key.toLowerCase(), false)}>;`)
                .join("\n")}

export namespace ${names.constant} {
  ${Object.entries(record)
                .map(([key, value]) => `// ${key}
export const ${key}:EnumsLabelKo<${smdId}${(0, inflection_1.camelize)(key.toLowerCase(), false)}> = {
  ${Object.entries(value)
                .map(([ek, ev]) => `"${ek}": { ko: "${ev}" }`)
                .join(",")}
};
      `)
                .join("\n")}
}
      `.trim(), importKeys: [] });
    }
}
exports.Template__init_enums = Template__init_enums;
//# sourceMappingURL=init_enums.template.js.map