"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Template__init_generated = void 0;
const entity_manager_1 = require("../entity/entity-manager");
const base_template_1 = require("./base-template");
class Template__init_generated extends base_template_1.Template {
    constructor() {
        super("init_generated");
    }
    getTargetAndPath(names) {
        return {
            target: "api/src/application",
            path: `${names.fs}/${names.fs}.generated.ts`,
        };
    }
    render({ entityId }) {
        const names = entity_manager_1.EntityManager.getNamesFromId(entityId);
        return Object.assign(Object.assign({}, this.getTargetAndPath(names)), { body: `
import { z } from "zod";

export const ${entityId}BaseSchema = z.object({});
export type ${entityId}BaseSchema = z.infer<typeof ${entityId}BaseSchema>;

export const ${entityId}BaseListParams = z.object({
  num: z.number().int().min(0),
  page: z.number().int().min(1),
  search: ${entityId}SearchField,
  keyword: z.string(),
  orderBy: ${entityId}OrderBy,
  withoutCount: z.boolean(),
}).partial();
export type ${entityId}BaseListParams = z.infer<typeof ${entityId}BaseListParams>;

export type ${entityId}SubsetKey = never;
export type ${entityId}SubsetMapping = {};
/* BEGIN- Server-side Only */
import { SubsetQuery } from "sonamu";
export const ${names.camel}SubsetQueries: { [key in ${entityId}SubsetKey]: SubsetQuery } = {};

export type ${entityId}FieldExpr = string;
/* END- Server-side Only */
      `.trim(), importKeys: [] });
    }
}
exports.Template__init_generated = Template__init_generated;
//# sourceMappingURL=init_generated.template.js.map