"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Template__init_types = void 0;
const entity_manager_1 = require("../entity/entity-manager");
const base_template_1 = require("./base-template");
class Template__init_types extends base_template_1.Template {
    constructor() {
        super("init_types");
    }
    getTargetAndPath(names) {
        return {
            target: "api/src/application",
            path: `${names.fs}/${names.fs}.types.ts`,
        };
    }
    render({ entityId }) {
        const names = entity_manager_1.EntityManager.getNamesFromId(entityId);
        const hasCreatedAt = entity_manager_1.EntityManager.get(entityId).props.find((prop) => prop.name === "created_at") !== undefined;
        return Object.assign(Object.assign({}, this.getTargetAndPath(names)), { body: `
import { z } from "zod";
import { ${entityId}BaseSchema, ${entityId}BaseListParams } from "../sonamu.generated";

// ${entityId} - ListParams
export const ${entityId}ListParams = ${entityId}BaseListParams;
export type ${entityId}ListParams = z.infer<typeof ${entityId}ListParams>;

// ${entityId} - SaveParams
export const ${entityId}SaveParams = ${entityId}BaseSchema.partial({ id: true${hasCreatedAt ? ", created_at: true" : ""} });
export type ${entityId}SaveParams = z.infer<typeof ${entityId}SaveParams>;

      `.trim(), importKeys: [] });
    }
}
exports.Template__init_types = Template__init_types;
//# sourceMappingURL=init_types.template.js.map