"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Template__model_test = void 0;
const entity_manager_1 = require("../entity/entity-manager");
const base_template_1 = require("./base-template");
class Template__model_test extends base_template_1.Template {
    constructor() {
        super("model_test");
    }
    getTargetAndPath(names) {
        return {
            target: "api/src/application",
            path: `${names.fs}/${names.fs}.model.test.ts`,
        };
    }
    render({ entityId }) {
        const names = entity_manager_1.EntityManager.getNamesFromId(entityId);
        return Object.assign(Object.assign({}, this.getTargetAndPath(names)), { body: `
import { describe, test, expect } from "vitest";
import { bootstrap } from '../../testing/bootstrap';

bootstrap([]);
describe.skip("${entityId}ModelTest", () => {
  test("Query", async () => {
    expect(true).toBe(true);
  });
});
      `.trim(), importKeys: [] });
    }
}
exports.Template__model_test = Template__model_test;
//# sourceMappingURL=model_test.template.js.map