"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Template__smd = void 0;
const entity_manager_1 = require("../smd/entity-manager");
const base_template_1 = require("./base-template");
class Template__smd extends base_template_1.Template {
    constructor() {
        super("smd");
    }
    getTargetAndPath(names) {
        return {
            target: "api/src/application",
            path: `${names.fs}/${names.fs}.smd.ts`,
        };
    }
    render(options) {
        const { smdId, title, refCode } = options;
        const names = entity_manager_1.EntityManager.getNamesFromId(smdId);
        return Object.assign(Object.assign({}, this.getTargetAndPath(names)), { body: `
import { p, i, SMDInput } from "sonamu";
import { ${smdId}FieldExpr } from "./${names.fs}.generated";

/*
  ${smdId} SMD
*/

export const ${names.camel}SmdInput: SMDInput<${smdId}FieldExpr> = {
  id: "${smdId}",
  title: "${title !== null && title !== void 0 ? title : smdId}",
  props: [
    p.integer("id", { unsigned: true }),
    p.timestamp("created_at", {
      now: true,
    }),
  ],
  indexes: [
    i.index('created_at'),
    //
  ],
  subsets: {
    A: [ 'id', 'created_at' ]
  }
};
${refCode ? `\n/* REFERENCE\n\n${refCode}\n*/` : ""}
`.trim(), importKeys: [] });
    }
}
exports.Template__smd = Template__smd;
//# sourceMappingURL=smd.template.js.map