"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Template__view_enums_select = void 0;
const entity_manager_1 = require("../entity/entity-manager");
const base_template_1 = require("./base-template");
const view_enums_dropdown_template_1 = require("./view_enums_dropdown.template");
class Template__view_enums_select extends base_template_1.Template {
    constructor() {
        super("view_enums_select");
    }
    getTargetAndPath(names, enumId) {
        return {
            target: "web/src/components",
            path: `${names.fs}/${enumId}Select.tsx`,
        };
    }
    render({ entityId, enumId }) {
        const names = entity_manager_1.EntityManager.getNamesFromId(entityId);
        const label = (0, view_enums_dropdown_template_1.getLabel)(entityId, enumId);
        return Object.assign(Object.assign({}, this.getTargetAndPath(names, enumId)), { body: `
import React from 'react';
import {
  Dropdown,
  DropdownProps,
} from 'semantic-ui-react';

import { ${enumId}, ${enumId}Label } from 'src/services/sonamu.generated';

export type ${enumId}SelectProps = {
  placeholder?: string;
  textPrefix?: string;
} & DropdownProps;
export function ${enumId}Select({placeholder, textPrefix, ...props}: ${enumId}SelectProps) {
  const typeOptions = ${enumId}.options.map((key) => ({
    key,
    value: key,
    text: (textPrefix ?? '${label}: ') + ${enumId}Label[key],
  }));

  return (
    <Dropdown
      placeholder={placeholder ?? "${label}"}
      selection
      options={typeOptions}
      selectOnBlur={false}
      {...props}
    />
  );
}
      `.trim(), importKeys: [] });
    }
}
exports.Template__view_enums_select = Template__view_enums_select;
//# sourceMappingURL=view_enums_select.template.js.map