"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Template__view_id_async_select = void 0;
const entity_manager_1 = require("../entity/entity-manager");
const base_template_1 = require("./base-template");
class Template__view_id_async_select extends base_template_1.Template {
    constructor() {
        super("view_id_async_select");
    }
    getTargetAndPath(names) {
        return {
            target: "web/src/components",
            path: `${names.fs}/${names.capital}IdAsyncSelect.tsx`,
        };
    }
    render({ entityId, textField }) {
        var _a;
        const names = entity_manager_1.EntityManager.getNamesFromId(entityId);
        const entity = entity_manager_1.EntityManager.get(entityId);
        if (!textField) {
            const pickedProp = entity.props.find((prop) => ["name", "title"].includes(prop.name));
            if (pickedProp) {
                textField = pickedProp.name;
            }
            else {
                const candidateProp = entity.props.find((prop) => prop.type === "string");
                if (candidateProp) {
                    textField = candidateProp.name;
                }
                else {
                    console.log("textField 찾을 수 없음");
                }
            }
        }
        return Object.assign(Object.assign({}, this.getTargetAndPath(names)), { body: `
import React, { useState, useEffect, SyntheticEvent } from "react";
import { DropdownProps, DropdownItemProps, DropdownOnSearchChangeData, Dropdown } from "semantic-ui-react";
import { ${names.capital}SubsetKey, ${names.capital}SubsetMapping } from "src/services/sonamu.generated";
import { ${names.capital}Service } from "src/services/${names.fs}/${names.fs}.service";
import { ${names.capital}ListParams } from "src/services/${names.fs}/${names.fs}.types";

export function ${names.capital}IdAsyncSelect<T extends ${names.capital}SubsetKey>(
  { subset, baseListParams, textField, valueField, ...props }: DropdownProps & {
    subset: T;
    baseListParams?: ${names.capital}ListParams;
    textField${textField ? "?" : ""}: keyof ${names.capital}SubsetMapping[T];
    valueField?: keyof ${names.capital}SubsetMapping[T];
  },
) {
  const [options, setOptions] = useState<DropdownItemProps[]>([]);
  const [listParams, setListParams] = useState<${names.capital}ListParams>(
    baseListParams ?? {},
  );

  const { data, error } = ${names.capital}Service.use${names.capitalPlural}(subset, listParams);
  const { rows: ${names.camelPlural}, total } = data ?? {};

  useEffect(() => {
    setOptions(
      (${names.camelPlural} ?? []).map((${names.camel}) => {
        return {
          key: ${names.camel}.id,
          value: ${names.camel}[valueField ?? 'id'] as string | number,
          text: String(${names.camel}[textField${textField ? ` ?? '${textField}'` : ""}]),
        };
      }),
    );
  }, [${names.camelPlural}]);

  useEffect(() => {
    setListParams({
      ...listParams,
      ...baseListParams,
    });
  }, [baseListParams]);

  const handleSearchChange = (
    e: SyntheticEvent<HTMLElement, Event>,
    data: DropdownOnSearchChangeData,
  ) => {
    setListParams({
      ...listParams,
      keyword: data.searchQuery,
    });
  };

  return (
    <Dropdown
      placeholder="${(_a = entity.title) !== null && _a !== void 0 ? _a : names.constant}"
      selection
      options={options}
      onSearchChange={handleSearchChange}
      disabled={!${names.camelPlural}}
      loading={!${names.camelPlural}}
      selectOnBlur={false}
      {...props}
    />
  );
}
      `.trim(), importKeys: [] });
    }
}
exports.Template__view_id_async_select = Template__view_id_async_select;
//# sourceMappingURL=view_id_async_select.template.js.map