import { RenderingNode, TemplateOptions } from "../types/types";
import { EntityNamesRecord } from "../entity/entity-manager";
import { RelationProp } from "../types/types";
import { Template } from "./base-template";
export declare class Template__view_list extends Template {
    constructor();
    getTargetAndPath(names: EntityNamesRecord): {
        target: string;
        path: string;
    };
    wrapTc(body: string, key: string, collapsing?: boolean, className?: string): string;
    renderColumn(entityId: string, col: RenderingNode, names: EntityNamesRecord, parentObj?: string, withoutName?: boolean): string;
    renderColumnImport(entityId: string, col: RenderingNode, names: EntityNamesRecord): (string | null)[];
    renderFilterImport(entityId: string, col: RenderingNode, names: EntityNamesRecord): string;
    renderFilter(entityId: string, col: RenderingNode, names: EntityNamesRecord): string;
    getDefault(columns: RenderingNode[]): {
        orderBy: string;
        search: string;
    };
    render({ entityId }: TemplateOptions["view_list"], columnsNode: RenderingNode, listParamsNode: RenderingNode): {
        body: string;
        importKeys: never[];
        preTemplates: {
            key: "entity" | "init_types" | "generated" | "generated_sso" | "generated_http" | "model" | "model_test" | "bridge" | "service" | "view_list" | "view_list_columns" | "view_search_input" | "view_form" | "view_id_all_select" | "view_id_async_select" | "view_enums_select" | "view_enums_dropdown" | "view_enums_buttonset";
            options: {
                entityId: string;
                title: string;
                parentId?: string | undefined;
                table?: string | undefined;
            } | {
                entityId: string;
            } | {} | {} | {
                entityId: string;
            } | {
                entityId: string;
                defaultSearchField: string;
                defaultOrderBy: string;
            } | {
                entityId: string;
            } | {
                entityId: string;
            } | {
                entityId: string;
            } | {
                entityId: string;
                extra?: unknown;
            } | {
                columns: {
                    name: string;
                    label: string;
                    tc: string;
                }[];
                entityId: string;
                columnImports: string;
            } | {
                entityId: string;
            } | {
                entityId: string;
            } | {
                entityId: string;
            } | {
                entityId: string;
                textField: string;
            } | {
                entityId: string;
                enumId: string;
            } | {
                entityId: string;
                enumId: string;
            } | {
                entityId: string;
                enumId: string;
            };
        }[];
        target: string;
        path: string;
    };
}
export declare function getEnumInfoFromColName(entityId: string, colName: string): {
    id: string;
    targetEntityNames: EntityNamesRecord;
    targetEntityId: string;
    title: string;
};
export declare function getRelationPropFromColName(entityId: string, colName: string): RelationProp;
//# sourceMappingURL=view_list.template.d.ts.map