"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Template__view_list_columns = void 0;
const entity_manager_1 = require("../entity/entity-manager");
const base_template_1 = require("./base-template");
class Template__view_list_columns extends base_template_1.Template {
    constructor() {
        super("view_list_columns");
    }
    getTargetAndPath(names) {
        return {
            target: "web/src/pages/admin",
            path: `${names.fsPlural}/_columns.tsx`,
        };
    }
    // 컬럼
    render({ entityId, columns, columnImports, }) {
        const names = entity_manager_1.EntityManager.getNamesFromId(entityId);
        return Object.assign(Object.assign({}, this.getTargetAndPath(names)), { body: `
import React from 'react';
import {
  Segment,
  Table,
  TableRow,
  Button,
  Label,
} from 'semantic-ui-react';
import { DateTime } from "luxon";
import { TFColumn } from "src/typeframe/iso-types";
import { ${names.capital}SubsetA } from "src/services/${names.fs}/${names.fs}.generated";
${columnImports}

const columns: { [key in Exclude<keyof ${names.capital}SubsetA, 'id'>]: TFColumn<${names.capital}SubsetA> } = {${columns
                .map((col) => {
                return [
                    `${col.name}: { label: "${col.label}",`,
                    `tc: ${col.tc}, `,
                    `collapsing: ${["Title", "Name"].includes(col.label) === false}, }`,
                ].join("\n");
            })
                .join(",\n")}};
export default columns;
      `.trim(), importKeys: [] });
    }
}
exports.Template__view_list_columns = Template__view_list_columns;
//# sourceMappingURL=view_list_columns.template.js.map