"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTest = exports.isProduction = exports.isStaging = exports.isDevelopment = exports.isDaemonServer = exports.isInDocker = exports.isRemote = exports.isLocal = void 0;
function isLocal() {
    return process.env.LR === undefined || process.env.LR === "local";
}
exports.isLocal = isLocal;
function isRemote() {
    return process.env.LR === "remote";
}
exports.isRemote = isRemote;
function isInDocker() {
    return process.env.LR !== undefined;
}
exports.isInDocker = isInDocker;
function isDaemonServer() {
    return process.env.NODE_TYPE === "daemon";
}
exports.isDaemonServer = isDaemonServer;
function isDevelopment() {
    return isRemote() && process.env.NODE_ENV === "development";
}
exports.isDevelopment = isDevelopment;
function isStaging() {
    return isRemote() && process.env.NODE_ENV === "staging";
}
exports.isStaging = isStaging;
function isProduction() {
    return isRemote() && process.env.NODE_ENV === "production";
}
exports.isProduction = isProduction;
function isTest() {
    return isLocal() && process.env.NODE_ENV === "test";
}
exports.isTest = isTest;
//# sourceMappingURL=controller.js.map