"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.nonNullable = exports.findApiRootPath = exports.findAppRootPath = exports.importMultiple = exports.globAsync = void 0;
const path_1 = __importDefault(require("path"));
const glob_1 = __importDefault(require("glob"));
const fs_1 = require("fs");
function globAsync(pathPattern) {
    return new Promise((resolve, reject) => {
        (0, glob_1.default)(path_1.default.resolve(pathPattern), (err, files) => {
            if (err) {
                reject(err);
            }
            else {
                resolve(files);
            }
        });
    });
}
exports.globAsync = globAsync;
function importMultiple(filePaths, doRefresh = false) {
    return __awaiter(this, void 0, void 0, function* () {
        return Promise.all(filePaths.map((filePath) => __awaiter(this, void 0, void 0, function* () {
            const importPath = "./" + path_1.default.relative(__dirname, filePath);
            if (doRefresh) {
                delete require.cache[require.resolve(importPath)];
            }
            const imported = yield Promise.resolve(`${importPath}`).then(s => __importStar(require(s)));
            return {
                filePath,
                imported,
            };
        })));
    });
}
exports.importMultiple = importMultiple;
function findAppRootPath() {
    return __awaiter(this, void 0, void 0, function* () {
        const apiRootPath = yield findApiRootPath();
        return apiRootPath.split(path_1.default.sep).slice(0, -1).join(path_1.default.sep);
    });
}
exports.findAppRootPath = findAppRootPath;
function findApiRootPath() {
    var _a, _b;
    return __awaiter(this, void 0, void 0, function* () {
        const basePath = (_b = (_a = require.main) === null || _a === void 0 ? void 0 : _a.path) !== null && _b !== void 0 ? _b : __dirname;
        let dir = path_1.default.dirname(basePath);
        if (dir.includes("/.yarn/")) {
            dir = dir.split("/.yarn/")[0];
        }
        do {
            if ((0, fs_1.existsSync)(path_1.default.join(dir, "/package.json"))) {
                return dir.split(path_1.default.sep).join(path_1.default.sep);
            }
            dir = dir.split(path_1.default.sep).slice(0, -1).join(path_1.default.sep);
        } while (dir.split(path_1.default.sep).length > 1);
        throw new Error("Cannot find AppRoot using Sonamu -2");
    });
}
exports.findApiRootPath = findApiRootPath;
function nonNullable(value) {
    return value !== null && value !== undefined;
}
exports.nonNullable = nonNullable;
//# sourceMappingURL=utils.js.map